/*
 *  Font 12x12 x2 -- WiFiBoy32 Demo Code for Arduino/ESP32
 *
 *  Oct 13, 2017 Created. (derek@wifiboy.org)
 *
 */
#include "wifiboy32.h"
#include "wbFontB12.h"

uint8_t bits[]={0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
uint8_t fbuf[18];
uint16_t _cx, _cy, i, j, count;
uint16_t _color1, _color2;

void showbits(uint8_t c, uint8_t n)
{
  for(int i=0; i<4; i++) {
    if (c & bits[i+n]) wb32_fillRect(_cx, _cy, 2, 2, _color1); // wb32_drawPixel(_cx, _cy, _color1);
    else wb32_fillRect(_cx, _cy, 2, 2, 0); // _color2); //wb32_drawPixel(_cx, _cy, 0); // _color2);
    _cx+=2;
  }
}

void dispfont(uint16_t n)
{
  memcpy_P(fbuf, (uint8_t *)(&b5f12[n*18]), 18);
  count = 0;
  for(int i=0; i<18; i++) {
    showbits(fbuf[i], 0);
    if (++count % 3 == 0) { _cx-=24; _cy+=2; } 
    showbits(fbuf[i], 4);
    if (++count % 3 == 0) { _cx-=24; _cy+=2; } 
  }
}

void setup() {
  wb32_init();
  wb32_fillScreen(0);
}

void loop() {
  _cx=(rand()%8)*30;
  _cy=(rand()%10)*32;
  _color1=(rand()%65536)|0x8410;
  //_color2=(rand()%65536)&0xfbef;
  dispfont(rand()%5401);
}
